package com.schoolinout.web.controller.api;

import com.schoolinout.common.core.controller.BaseController;
import com.schoolinout.common.core.domain.AjaxResult;
import com.schoolinout.system.domain.dto.InOutLogDto;
import com.schoolinout.system.service.IAccessLogService;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author sakura
 * @date 2024/1/10 15:15:04 Wed
 */
@Tag(name = "用户端-查看学生进出记录接口")
@RequestMapping("/app/inout")
@RestController
public class Api_AccessLogController extends BaseController {

    @Autowired
    private IAccessLogService accessLogService;

    /**
     * 查询学生进出学校记录
     */
    @PostMapping("/student/list")
    public AjaxResult searchStudentInOutLog(@RequestBody InOutLogDto dto) {
        return success(accessLogService.queryStudentInOutLog(dto));
    }
}
