package com.schoolinout.api.service;

import com.schoolinout.api.domain.vo.Api_StudentInfoVo;
import com.schoolinout.api.domain.vo.Api_StudentListVo;
import com.schoolinout.system.domain.Student;

import java.util.List;

/**
 * @author sakura
 * @date 2024/1/10 10:10:05 Wed
 */
public interface IApiStudentService {
    /**
     * 获取绑定学生详情
     *
     * @param parentId  家长id
     * @param studentId 学生id
     * @return 结果
     */
    public Api_StudentInfoVo listStudentEditInfo(Long parentId, Long studentId);

    /**
     * 查询单个用户
     *
     * @param selectConditionStu 查询条件
     * @return 结果
     */
    public Student listStudentSimple(Student selectConditionStu);

    /**
     * 根据当前登入家长的id 去查询绑定的学生列表
     *
     * @param parentId 家长id
     * @return 结果
     */
    public List<Api_StudentListVo> listStudent(Long parentId);
}
